#pragma once
//(  10  2007)
//        
//      (e_hdrLen_32_commonLen )
//   (e_Len_1024_FreqArray )

class CHuffman
{
	enum
	{
		e_Version=1,				// 
		e_ControlTail	=	0x00,	//     
		e_Signature0='h',			//    
	};

	enum
	{
		//     
		e_Condition0=0,// !!!
		e_Condition1=1,// !!!
	};

	enum
	{
		e_AlphaSize=256,//  ( 256 )
	};

	//     
	enum
	{
		sizemax_default		=	(0xffffffff>>1),
	};


	//    
	//(      
	// MakeCompressedData  UnPackDataEx.
	//       
	// )
	enum
	{
		// 
		e_hdrLen_1_Signature		=	1,		//(1) -   
		e_hdrLen_1_version			=	1,		//(2)
		e_hdrLen_4_SizeOfArhiv		=	4,		//(3)
		e_hdrLen_4_SizeOfSourFile	=	4,		//(4)
		e_hdrLen_6_16_Reserv1		=	6+16,	//(5)

		//  
		e_hdrLen_32_commonLen		=	32,		//   
	};


	//  
	enum
	{
		e_Len_1024_FreqArray			=	e_AlphaSize*sizeof(DWORD),
	};

	//  
	struct s_dict_word
	{
		public:
		enum{e_pole_bytes=32};

		private:
		enum{e_pole_bytes_plus1BYTE=e_pole_bytes+1};

		public:
		BYTE byChar;		// 
		WORD wHuffCodeLen;	//    
		DWORD dwdFreq;		// 

		//  (   -   )
		public:
		//     , 
		//  e_pole_bytes
		BYTE pole [e_pole_bytes_plus1BYTE];
		private:
		//  (  )   .
		//  (   
		// -      
		// )
		BYTE pole1[e_pole_bytes_plus1BYTE];
		BYTE pole2[e_pole_bytes_plus1BYTE];
		BYTE pole3[e_pole_bytes_plus1BYTE];
		BYTE pole4[e_pole_bytes_plus1BYTE];
		BYTE pole5[e_pole_bytes_plus1BYTE];
		BYTE pole6[e_pole_bytes_plus1BYTE];
		BYTE pole7[e_pole_bytes_plus1BYTE];

		public:
		s_dict_word()
		{
			memset(this,0,sizeof(*this));
		}

		const BYTE* ChoosePoleArrayByBitShift(BYTE bitz)
		{
			//     
			//(   -   
			// )
			switch(bitz&0x07)
			{
				default: return 0;	break;
										  //   curr  |  already filled data
				case 0:return pole ;break;// ........|76543210|76543210|
				case 1:return pole1;break;// .......0|76543210|76543210|
				case 2:return pole2;break;// ......10|76543210|76543210|
				case 3:return pole3;break;// .....210|76543210|76543210|
				case 4:return pole4;break;// ....3210|76543210|76543210|
				case 5:return pole5;break;// ...43210|76543210|76543210|
				case 6:return pole6;break;// ..543210|76543210|76543210|
				case 7:return pole7;break;// .6543210|76543210|76543210|
			}
		}

		//  pole    
		//  (    )

		void GenerateAdditionalCodes()
		{
			BYTE byCarry=0;
			BYTE by;
			WORD w;


			// :
			//
			//(e_pole_bytes_plus1BYTE-1)
			//   |
			//   |     (e_pole_bytes-1)
			//   |     (e_pole_bytes_plus1BYTE-2)
			//   |         |
			//   | <--w--> |
			//   |         |
			//   |   ( )
			//   |         |
			//00000000 76543210 ........  //pole
			//00000007 6543210. ........  //pole1
			//00000076 543210.. ........  //pole2
			//00000765 43210... ........  //pole3
			//00007654 3210.... ........  //pole4
			//00076543 210..... ........  //pole5
			//00765432 10...... ........  //pole6
			//07654321 0....... ........  //pole7

			for(DWORD dwd=e_pole_bytes_plus1BYTE-2;dwd!=-1;dwd--)
			{
				w=*((WORD*)&pole[dwd]);

				w<<=1; pole1[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole2[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole3[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole4[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole5[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole6[dwd+1]=*(1+(BYTE*)&w);
				w<<=1; pole7[dwd+1]=*(1+(BYTE*)&w);
			}

			//    .
			by=pole[0];
			by<<=1; pole1[0]=by;
			by<<=1; pole2[0]=by;
			by<<=1; pole3[0]=by;
			by<<=1; pole4[0]=by;
			by<<=1; pole5[0]=by;
			by<<=1; pole6[0]=by;
			by<<=1; pole7[0]=by;
		}
	};

	// 
	struct s_Knot
	{
		DWORD dwdFreq;
		BYTE byChar;
		s_Knot* pParent;//  
		s_Knot* pOrigKnotOfTree_IfNotLeaf;
		const s_Knot* pChild_0;//   0
		const s_Knot* pChild_1;//   1
		bool bIsNotLeaf;//  -  
		BYTE byConditionToGetParent;//     (e_Condition0,e_Condition1)

		s_Knot()
		{
			memset(this,0,sizeof(*this));
		}
	};

	//  == 0,    
	// !=0   ,   - 

	s_Knot* m_KnotsHeap;//  

	s_Knot* m_pROOT;//  
	s_Knot* m_Tree;// (  )
	DWORD m_dwdKnotsNumInTree;//  

	s_Knot* m_Leafs;// 
	DWORD m_dwdKnotsNumInLeafs;//  

	DWORD m_dwdHuffCodeMaxLen;//    

	s_dict_word* Dictionary;

public:
	BYTE* pUnpackBuffer;
	BYTE* pArhivBuffer;



	void ClearKnotsArrays()
	{
		if(m_KnotsHeap)memset(m_KnotsHeap,0,e_AlphaSize*sizeof(*m_KnotsHeap));

		if(m_Tree)memset(m_Tree,0,e_AlphaSize*sizeof(*m_Tree));
		m_dwdKnotsNumInTree=0;

		if(m_Leafs)memset(m_Leafs,0,e_AlphaSize*sizeof(*m_Leafs));
		m_dwdKnotsNumInLeafs=0;

		if(m_pROOT)memset(m_pROOT,0,sizeof(*m_pROOT));
		

		m_dwdHuffCodeMaxLen=0;
	}

	//   (0...255)
	bool CountFreqzInData(
		const BYTE* pBuf,
		const DWORD dwdLen,
		bool bSortKnotsThenByFreq_asc,
		bool bFileIsFreqArray //     pBuf,dwdLen
		)
	{
		DWORD dwd;

		if(!bFileIsFreqArray)
		{
			//     

			//   
			if(dwdLen>=sizemax_default)return false;

			//   
			for(dwd=0;dwd<dwdLen;dwd++)
			{
				m_KnotsHeap[pBuf[dwd]].dwdFreq++;
			}
		}
		else
		{
			//     pBuf,dwdLen
			if(dwdLen!=e_Len_1024_FreqArray)return false;
			DWORD* pdwd=(DWORD*)pBuf;
			// 
			for(dwd=0;dwd<e_AlphaSize;dwd++,pdwd++)
			{
				m_KnotsHeap[dwd].dwdFreq=*pdwd;
			}
		}

		// m_KnotsHeap   
		if(bSortKnotsThenByFreq_asc)
		{
			s_Knot temp;
			s_Knot* pPosFound=0;

			for(DWORD dwdBeg=0;dwdBeg+1<e_AlphaSize;dwdBeg++)
			{
				//   .

				//      ,
				if(dwdBeg)
				{
					if(m_KnotsHeap[dwdBeg].dwdFreq==m_KnotsHeap[dwdBeg-1].dwdFreq)
					{
						continue;
					}
				}

				//     [dwdBeg...e_AlphaSize-1]
				DWORD dwdMin=m_KnotsHeap[dwdBeg].dwdFreq;
				pPosFound=0;//dwdBeg;
				for(dwd=dwdBeg;dwd<e_AlphaSize;dwd++)
				{
					if(m_KnotsHeap[dwd].dwdFreq<=dwdMin)
					{
						pPosFound=&m_KnotsHeap[dwd];
						dwdMin=pPosFound->dwdFreq;
					}
				}

				//     
				if(pPosFound)
				{
					//   [dwdBeg]  [dwdPosFound]
					temp=*pPosFound;
					*pPosFound=m_KnotsHeap[dwdBeg];
					m_KnotsHeap[dwdBeg]=temp;
				}
			}
		}

		return true;
	}

	//  ,  
	bool MakeTree(
		const BYTE* const pFile,
		const DWORD dwdFileLen_in,
		BYTE& byerrorcode
		)
	{
		return MakeTreeEx(pFile,dwdFileLen_in,byerrorcode,false);
	}

	bool MakeTreeEx(
		const BYTE* const pFile,
		const DWORD dwdFileLen_in,
		BYTE& byerrorcode,
		bool bFileIsFreqArray //     pFile,dwdFileLen_in
		)
	{
		byerrorcode=0;

		DWORD dwd;

		//  
		// 
		ClearKnotsArrays();
		//m_dwdKnotsNumInTree==0
		//m_dwdKnotsNumInLeafs==0
		//m_dwdHuffCodeMaxLen==0

		//     
		for(dwd=0;dwd<e_AlphaSize;dwd++)
		{
			m_KnotsHeap[dwd].byChar=(BYTE)dwd;
		}


		if(!bFileIsFreqArray)
		{
			//((1))     (   
			//     ,  
			//  ).
			if(!CountFreqzInData(pFile,dwdFileLen_in,true,false))
			{
				byerrorcode=1;
				return false;
			}
		}
		else
		{
			//((1))      pFile,dwdFileLen_in
			if(!CountFreqzInData(pFile,dwdFileLen_in,true,true))
			{
				byerrorcode=2;
				return false;
			}
		}

		//m_KnotsHeap[e_AlphaSize] - ,  
		//   !

		//,     
		DWORD dwdCurrKnotToBeginFrom=-1;
		for(dwd=0;dwd<e_AlphaSize;dwd++)
		{
			if(m_KnotsHeap[dwd].dwdFreq==0)continue;
			dwdCurrKnotToBeginFrom=dwd;
			break;
		}


		if(dwdCurrKnotToBeginFrom==-1)
		{
			byerrorcode=3;
			return false;
		}

		// 
		s_Knot temp;
		const s_Knot* pK0;
		const s_Knot* pK1;
		s_Knot* pNewTreeKnot;
		s_Knot* pL0;
		s_Knot* pL1;

		for(;;)
		{
			pK0=0;
			pK1=0;
			pNewTreeKnot=0;
			pL0=0;
			pL1=0;

			if(dwdCurrKnotToBeginFrom>e_AlphaSize)
			{
				// 
				byerrorcode=4;
				break;
			}

			//((2))    2    .

			if(dwdCurrKnotToBeginFrom==e_AlphaSize)
			{
				//    m_KnotsHeap -  
				//pROOT=&m_KnotsHeap[dwdCurrKnotToBeginFrom];
				//m_pROOT
				break;
			}

			//    
			pK0=0;
			if(dwdCurrKnotToBeginFrom<e_AlphaSize)
			{
				pK0=&m_KnotsHeap[dwdCurrKnotToBeginFrom];
				dwdCurrKnotToBeginFrom++;
			}

			//    
			pK1=0;
			if(dwdCurrKnotToBeginFrom<e_AlphaSize)
			{
				pK1=&m_KnotsHeap[dwdCurrKnotToBeginFrom];
				dwdCurrKnotToBeginFrom++;
			}

			//((3))       ,
			//  ,     .
			//      
			//   .

			//  m_Tree   ,  =    
			//     ,   
			//m_Tree[m_dwdKnotsNumInTree].dwdFreq = pK0->dwdFreq + pK1->dwdFreq
			//   /           \  
			//  /             \  
			// pL0 (<=pK0)   pL1 (<=pK1)


			//    
			//(,    -  )
			//(dwdCurrKnotToBeginFrom   
			//,   !!!)
			{
				//m_pROOT
				if(dwdCurrKnotToBeginFrom==e_AlphaSize)
				{
					//  -  
					pNewTreeKnot=m_pROOT;
				}
				else
				{
					if(m_dwdKnotsNumInTree>e_AlphaSize)
					{
						//    m_Tree    (?)
						byerrorcode=6;
						break;
					}
					pNewTreeKnot=&m_Tree[m_dwdKnotsNumInTree];

					//   
					m_dwdKnotsNumInTree++;
				}

				//   
				//(,     m_KnotsHeap - , ,
				//   ,     
				//)
				pNewTreeKnot->pOrigKnotOfTree_IfNotLeaf=pNewTreeKnot;

				// -    (  )
				pNewTreeKnot->dwdFreq=0;
				if(pK0)pNewTreeKnot->dwdFreq+=pK0->dwdFreq;
				if(pK1)pNewTreeKnot->dwdFreq+=pK1->dwdFreq;

				//   (   -   )
				pNewTreeKnot->pParent=0;
				//  
				pNewTreeKnot->bIsNotLeaf=true;

				//  
			}

			if(pK0)
			{
				if(pK0->bIsNotLeaf)
				{
					//      ,
					//  
					pK0->pOrigKnotOfTree_IfNotLeaf->pParent=pNewTreeKnot;
					//    -      0
					pK0->pOrigKnotOfTree_IfNotLeaf->pParent->pChild_0=
										pK0->pOrigKnotOfTree_IfNotLeaf;

					//  ,  0 
					pK0->pOrigKnotOfTree_IfNotLeaf->byConditionToGetParent=e_Condition0;
				}
				else
				{
					if(m_dwdKnotsNumInLeafs==e_AlphaSize)
					{
						//    m_Leafs    (?)
						byerrorcode=7;
						break;
					}

					//    ,    
					pL0=&m_Leafs[m_dwdKnotsNumInLeafs];
					*pL0=*pK0;
					// 
					pL0->pParent=pNewTreeKnot;
					//    -      0
					pL0->pParent->pChild_0=pL0;
					//  ,  0 
					pL0->byConditionToGetParent=e_Condition0;
					m_dwdKnotsNumInLeafs++;
				}
			}

			if(pK1)
			{
				if(pK1->bIsNotLeaf)
				{
					//      ,
					//  
					pK1->pOrigKnotOfTree_IfNotLeaf->pParent=pNewTreeKnot;
					//    -      1
					pK1->pOrigKnotOfTree_IfNotLeaf->pParent->pChild_1=
										pK1->pOrigKnotOfTree_IfNotLeaf;
					//  ,  1 
					pK1->pOrigKnotOfTree_IfNotLeaf->byConditionToGetParent=e_Condition1;
				}
				else
				{
					if(m_dwdKnotsNumInLeafs==e_AlphaSize)
					{
						//    m_Leafs    (?)
						byerrorcode=8;
						break;
					}

					pL1=&m_Leafs[m_dwdKnotsNumInLeafs];
					*pL1=*pK1;
					pL1->pParent=pNewTreeKnot;
					//    -      1
					pL1->pParent->pChild_1=pL1;
					//  ,  1 
					pL1->byConditionToGetParent=e_Condition1;
					m_dwdKnotsNumInLeafs++;
				}
			}

			//((4))     .

			// :   
			//  m_KnotsHeap   
			{
				s_Knot* pKD=0;

				DWORD dwdCurrDeletingKnot=dwdCurrKnotToBeginFrom-1;

				pKD=&m_KnotsHeap[dwdCurrDeletingKnot];

				//    (m_KnotsHeap)
				// 2 ,      2  m_KnotsHeap
				//(  -  ,   )
				*pKD=*pNewTreeKnot;
				
				//   .
				//   dwdCurrDeletingKnot,   
				//    m_KnotsHeap,    
				for(dwd=dwdCurrDeletingKnot+1;dwd<e_AlphaSize;dwd++)
				{
					if(pKD->dwdFreq<=m_KnotsHeap[dwd].dwdFreq)
					{
						break;
					}
				}

				//,     
				dwd--;
				if(dwd>dwdCurrDeletingKnot)
				{
					//   [dwdCurrDeletingKnot+1 ... dwd]   [dwdCurrDeletingKnot]

					// 1   {7}  {3....4....5}   9
					//      |    |         |
					//     pKD  (pKD+1)   [dwd]
					//           ||
					//     [dwdCurrDeletingKnot+1]

					temp=*pKD;

					memmove(pKD,pKD+1,sizeof(*pKD)*(dwd-dwdCurrDeletingKnot));
					pKD=0;

					m_KnotsHeap[dwd]=temp;
				}
			}

			//""    ,      
			if(dwdCurrKnotToBeginFrom<e_AlphaSize)
			{
				dwdCurrKnotToBeginFrom--;
			}

			//     
		}

		if(byerrorcode)
		{
			return false;
		}

		return true;
	}

	bool MakeDictionary(QWORD& qwSumBits_out)
	{
		return MakeDictionaryEx(qwSumBits_out);
	}


	bool MakeDictionaryEx(QWORD& qwSumBits_out)
	{
		qwSumBits_out=0;
		m_dwdHuffCodeMaxLen=0;

		//m_Tree[m_dwdKnotsNumInTree] -  []
		//m_Leafs[m_dwdKnotsNumInLeafs] -  []

		// 
		if(Dictionary)
		{
			delete [] Dictionary;
			Dictionary=0;
		}

		Dictionary=new s_dict_word[e_AlphaSize];

		// 
		DWORD dwdL;
		s_dict_word* pWrd=0;
		s_Knot* pK=0;
		qwSumBits_out=0;
		m_dwdHuffCodeMaxLen=0;
		for(dwdL=0;dwdL<m_dwdKnotsNumInLeafs;dwdL++)
		{
			pK=&m_Leafs[dwdL];
			pWrd=&Dictionary[(BYTE)pK->byChar];

			pWrd->byChar=pK->byChar;
			pWrd->dwdFreq=pK->dwdFreq;

			//   
			DWORD dwdPoleBytezNum=0;

			//   ~    
			// ,      ,
			//      
			//   0  
			//(       )

			//      
			for(;;)
			{
				if(!pK->pParent)break;
				pWrd->wHuffCodeLen++;
				if(pWrd->wHuffCodeLen>=s_dict_word::e_pole_bytes*8)
				{
					return false;// 
				}

				//     , ,
				//      
				dwdPoleBytezNum=(pWrd->wHuffCodeLen>>3)+1;

				//    1  
				//      
				BYTE byCurrCarry=0;
				BYTE byPrevCarry;

				// == (bool)
				byPrevCarry=pK->byConditionToGetParent;

				for(DWORD dwdpole=0;dwdpole<dwdPoleBytezNum;dwdpole++)
				{
					//  
					byCurrCarry=(pWrd->pole[dwdpole]&0x80);
					//
					pWrd->pole[dwdpole]<<=1;
					//  
					if(byPrevCarry)
					{
						pWrd->pole[dwdpole]|=1;
					}
					//     
					byPrevCarry=byCurrCarry;
				}

				//  
				pK=pK->pParent;
			}
			pK=0;//!!!

			//    
			qwSumBits_out+=(pWrd->dwdFreq*pWrd->wHuffCodeLen);

			//  
			m_dwdHuffCodeMaxLen=max(m_dwdHuffCodeMaxLen,pWrd->wHuffCodeLen);

			pWrd->GenerateAdditionalCodes();
		}

		//
		return true;
	}

	//   
	DWORD CalcSizeOfPressedFile(const QWORD qwSumBits_in,bool bGetMinSizeOfArhive=false)
	{
		QWORD qwSize=0;

		// :

		// 
		qwSize+=e_hdrLen_32_commonLen;

		//  (_)
		qwSize+=e_Len_1024_FreqArray;

		if(!bGetMinSizeOfArhive)
		{
			//  == (qwSumBits_in+7)/8 
			qwSize+=(DWORD)((qwSumBits_in+7)/8);
		}


		qwSize=min(qwSize,0xffffffff);

		return (DWORD)qwSize;
	}

	bool MakeCompressedData(
		const BYTE* const pFile_in,
		const DWORD dwdFileLen_in,
		const DWORD dwdPressedDataLen_in
		)
	{
		if(pArhivBuffer)
		{
			delete [] pArhivBuffer;
			pArhivBuffer=0;
		}

		//    
		//(+1 -   ,   e_ControlTail.
		//         )
		pArhivBuffer=new BYTE[dwdPressedDataLen_in+1];
		memset(pArhivBuffer,0,dwdPressedDataLen_in);
		pArhivBuffer[dwdPressedDataLen_in]=e_ControlTail;

		BYTE* pPos=pArhivBuffer;
		//   
		QWORD qwDestBitWritted=0;//  
		QWORD qwDestBitsMaxToBeWritted=dwdPressedDataLen_in*8;

		#define check_pPos_delta_decBits_retfalse(deltaBits) \
			if(qwDestBitWritted+deltaBits>qwDestBitsMaxToBeWritted)return false

		#define shift_pPos_delta_decBits_retfalse(deltaBits) \
			qwDestBitWritted+=deltaBits;\
			pPos=pArhivBuffer+(qwDestBitWritted>>3)


		#define check_pF_delta_retfalse(delta) if(pF+delta>=pFMax_nzb)return false

		DWORD dwdBitzToWrite;
		//

		//
		dwdBitzToWrite=e_hdrLen_1_Signature*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		*pPos=e_Signature0;
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);

		//
		dwdBitzToWrite=e_hdrLen_1_version*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		*pPos=e_Version;
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);

		//  
		dwdBitzToWrite=e_hdrLen_4_SizeOfArhiv*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		*((DWORD*)pPos)=dwdPressedDataLen_in;
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		

		//  
		dwdBitzToWrite=e_hdrLen_4_SizeOfSourFile*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		*((DWORD*)pPos)=dwdFileLen_in;
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);

		//
		dwdBitzToWrite=e_hdrLen_6_16_Reserv1*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		//*pPos=...
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);

		// , _ * sizeof(DWORD)= 256*4 = 1024
		dwdBitzToWrite=e_Len_1024_FreqArray*8;
		check_pPos_delta_decBits_retfalse(dwdBitzToWrite);
		//
		for(DWORD dwd=0;dwd<e_AlphaSize;dwd++)
		{
			*((DWORD*)pPos)=Dictionary[dwd].dwdFreq;
			pPos+=sizeof(DWORD);			
		}
		shift_pPos_delta_decBits_retfalse(dwdBitzToWrite);

		//     
		const BYTE* pF=pFile_in;
		const BYTE* pFMax_nzb=pFile_in+dwdFileLen_in;
		s_dict_word* pWrd=0;


		for(;;pF++)
		{
			//pF -    ,   
			//qwDestBitWritted -    

			//,      
			if(pF>=pFMax_nzb)break;



			//  


			//   
			pWrd=&Dictionary[(BYTE)*pF];
			dwdBitzToWrite=pWrd->wHuffCodeLen;

			//,     
			//(  pPos)
			check_pPos_delta_decBits_retfalse(dwdBitzToWrite);

			//pPos -   ,    


			// 

			//,  ""   
			DWORD dwdFilledDataTail=(DWORD)(qwDestBitWritted&0x07);

			//       
			//     (
			//      
			// )
			const BYTE* pWorkingPole=pWrd->ChoosePoleArrayByBitShift((BYTE)dwdFilledDataTail);

			//    == dwdBitzToWrite

			//       , 
			//    "" ( 
			// ,  ,    
			//)
			if(dwdFilledDataTail)
			{
				//  (8-dwdFilledDataTail) 
				(*pPos)|=pWorkingPole[0];

				//     
				pWorkingPole++;

				//     
				pPos++;

				//,    
				if(dwdBitzToWrite<=(8-dwdFilledDataTail))
				{
					//     
					dwdBitzToWrite=0;
				}
				else
				{
					dwdBitzToWrite-=(8-dwdFilledDataTail);
				}
			}


			//    ,    
			//  ,   , 
			//   . ((dwdBitzToWrite+7)>>3)
			if(dwdBitzToWrite)
			{
				memmove(pPos,&pWorkingPole[0],(dwdBitzToWrite+7)>>3);
			}

			// 
			shift_pPos_delta_decBits_retfalse(pWrd->wHuffCodeLen);
		}

		// 
		{
			//  
			if( (((qwDestBitWritted+7)>>3)<<3) != qwDestBitsMaxToBeWritted)return false;

			// 
			if(pArhivBuffer[dwdPressedDataLen_in]!=e_ControlTail)return false;

			shift_pPos_delta_decBits_retfalse(0);// pPos;
			//pPos         
			if(pPos>&pArhivBuffer[dwdPressedDataLen_in])return false;

			shift_pPos_delta_decBits_retfalse(-1);// pPos;
			//pPos      
			if(pPos!=&pArhivBuffer[dwdPressedDataLen_in-1])return false;

		}

		return true;

		#undef check_pPos_delta_decBits_retfalse
		#undef shift_pPos_delta_decBits_retfalse
		#undef check_pF_delta_retfalse
	};





	bool PackDataEx(
		CWnd* pWinForMessages,
		const BYTE* const pFile_in,
		const DWORD dwdFileLen_in,
		DWORD* pdwdPressedDataLen_out,
		const DWORD dwdLimitSize=0,
		const bool bJustGetArhiveSizeAndMakeTree=false)
	{
		if(pdwdPressedDataLen_out)*pdwdPressedDataLen_out=0;

		BYTE byErr=0;

		if(!MakeTree(pFile_in,dwdFileLen_in,byErr))
		{
			//    byErr
			if(pWinForMessages)
			{
				CString txt;
				txt.Format(" %u    (m_Tree)",byErr);
				pWinForMessages->MessageBox(txt,"",MB_SYSTEMMODAL);
			}

			return false;
		}

		// .
		//m_pROOT -   
		//m_Tree[m_dwdKnotsNumInTree] -  []
		//m_Leafs[m_dwdKnotsNumInLeafs] -  []

		//
		QWORD qwSumBits;
		//DWORD dwdLenOfHuffmanCode;
		if(!MakeDictionary(qwSumBits))
		{
			return false;
		}

		//  
		DWORD dwdPressedDataLen=CalcSizeOfPressedFile(qwSumBits);

		if(dwdPressedDataLen==-1)return false;

		//
		if(dwdLimitSize)
		{
			if(dwdPressedDataLen>dwdLimitSize)return false;
		}

		if(bJustGetArhiveSizeAndMakeTree)
		{
			//   
			if(pdwdPressedDataLen_out)*pdwdPressedDataLen_out=dwdPressedDataLen;
			return true;
		}

		//  
		if(!MakeCompressedData(pFile_in,dwdFileLen_in,dwdPressedDataLen) ||
			!pArhivBuffer )
		{
			if(pWinForMessages)pWinForMessages->MessageBox("  ");
			return false;
		}

		if(pdwdPressedDataLen_out)*pdwdPressedDataLen_out=dwdPressedDataLen;

		return true;
	}

	//
	bool UnPackDataEx(const BYTE* const pArhFile_in,const DWORD dwdArhFileLen_in,DWORD& dwdUnpackedFileLen_out,const bool bJustCheckArhiveFormat=false)
	{
		dwdUnpackedFileLen_out=0;

		if(dwdArhFileLen_in<=CalcSizeOfPressedFile(0,true))return false;

		const BYTE* pPos=pArhFile_in;
		const BYTE* pPosMax_nzb=pArhFile_in+dwdArhFileLen_in;

		DWORD dwd;

		//

		//
		if(*pPos != e_Signature0)return false;
		pPos+=e_hdrLen_1_Signature;

		//
		if(*pPos != e_Version)return false;
		pPos+=e_hdrLen_1_version;

		//  
		if(	*((DWORD*)pPos) != dwdArhFileLen_in)return false;
		pPos+=e_hdrLen_4_SizeOfArhiv;

		//  
		dwdUnpackedFileLen_out=*((DWORD*)pPos);
		if(!dwdUnpackedFileLen_out || dwdUnpackedFileLen_out>sizemax_default)return false;
		pPos+=e_hdrLen_4_SizeOfSourFile;

		//(  0)
		for(dwd=0;dwd<e_hdrLen_6_16_Reserv1;dwd++)
		{
			if(*pPos)return false;
		}
		pPos+=e_hdrLen_6_16_Reserv1;


		if(bJustCheckArhiveFormat)return true;

		//  , _ * sizeof(DWORD)= 256*4 = 1024
		BYTE byErr=0;

		if(!MakeTreeEx(pPos,e_Len_1024_FreqArray,byErr,true))
		{
			return false;
		}

		pPos+=e_Len_1024_FreqArray;

		if(pUnpackBuffer)
		{
			delete [] pUnpackBuffer;
			pUnpackBuffer=0;
		}
		pUnpackBuffer=new BYTE[dwdUnpackedFileLen_out];


		// 

		//:
		//     .
		//  ,  
		//  .      -
		//        .
		//    -  ,   
		//.      
		//    -  . .
		//( ,   pPos<pPosMax_nzb)

		//m_pROOT


		BYTE* pF=pUnpackBuffer;//pF<pFMax_nzb
		BYTE* pFMax_nzb=pF+dwdUnpackedFileLen_out;
		const s_Knot* pK=m_pROOT;

		//  
		BYTE byMask=1;
		for(;pPos<pPosMax_nzb;)
		{
			//       
			//  
			if( (*pPos)&byMask )
			{
				pK=pK->pChild_1;//e_Condition1
			}
			else
			{
				pK=pK->pChild_0;//e_Condition0
			}

			// - pK   ?
			if(pK->bIsNotLeaf)
			{
				//
			}
			else
			{
				//

				//    -  
				if(pK->pChild_0 || pK->pChild_1)return false;



				// 
				*pF=pK->byChar;

				pF++;
				// -    
				if(pF>=pFMax_nzb)break;

				//   
				pK=m_pROOT;
			}

			if(!(byMask<<=1))
			{
				byMask=1;
				pPos++;
			}
		}

		return true;
	}


public:

	CHuffman()
	{
		memset(this,0,sizeof(*this));

		m_KnotsHeap=new s_Knot[e_AlphaSize];
		m_Tree=new s_Knot [e_AlphaSize];
		m_Leafs=new s_Knot[e_AlphaSize];
		m_pROOT=new s_Knot;
	}

	~CHuffman()
	{
		if(m_KnotsHeap)		{delete [] m_KnotsHeap;		m_KnotsHeap=0;	}
		if(m_Tree)			{delete [] m_Tree;			m_Tree=0;		}
		if(m_Leafs)			{delete [] m_Leafs;			m_Leafs=0;		}
		if(Dictionary)		{delete [] Dictionary;		Dictionary=0;	}
		if(pArhivBuffer)	{delete [] pArhivBuffer;	pArhivBuffer=0;	}
		if(pUnpackBuffer)	{delete [] pUnpackBuffer;	pUnpackBuffer=0;}

		if(m_pROOT)			{delete m_pROOT;			m_pROOT=0;		}
	}

	void PrintSummary(CString* pcsSummary,const DWORD dwdFileLen_in,const DWORD dwdPressedDataLen)
	{
		CString t,csEmpty;
		*pcsSummary="";

		if(!m_dwdHuffCodeMaxLen)return;

		CString& txt= *pcsSummary;

		#define def_isPrint(ch) ((bool)((ch)!=0 && (ch)!='\r' && (ch)!='\n' && (ch)!='\t'))

		DWORD dwdL;
		s_dict_word* pWrd;
		txt="S(dec)\tFreq\tCdLen\tPole(h<--l)\r\n";
		for(dwdL=0;dwdL<e_AlphaSize;dwdL++)
		{
			pWrd=&Dictionary[dwdL];
			t.Format("'%c' (%03u)\t%u\t%u\t",def_isPrint(pWrd->byChar)?pWrd->byChar:' ',pWrd->byChar,pWrd->dwdFreq,pWrd->wHuffCodeLen);
			txt+=t;

			//  
			t="";
			csEmpty="";

			DWORD pole_dwdByteNum=0;
			BYTE pole_byBitMask=1;
			for(DWORD dwd=0;dwd<m_dwdHuffCodeMaxLen;dwd++)
			{
				if(pole_dwdByteNum<pWrd->e_pole_bytes)
				{
					if(dwd<pWrd->wHuffCodeLen)
					{
						if(pWrd->pole[pole_dwdByteNum]&pole_byBitMask)
						{
							t+="1";
						}
						else
						{
							t+="0";
						}
					}
					else
					{
						csEmpty+="0";
					}
				}
				else
				{
					t+="?";
				}

				pole_byBitMask<<=1;
				if(!pole_byBitMask)
				{
					pole_dwdByteNum++;
					pole_byBitMask=1;
				}
			}
			t.MakeReverse();

			txt+=(csEmpty+t);

			txt+="\t";
			txt+=(t+csEmpty);

			txt+="\r\n";

		}

		txt+="-------------------------\r\n";

		{
			t.Format("   =%u ",m_dwdHuffCodeMaxLen);
			txt+=t+"\r\n";

			t.Format("   =%u ",dwdFileLen_in);
			txt+=t+"\r\n";

			t.Format("   =%u ",dwdPressedDataLen);
			txt+=t+"\r\n";

			t.Format("  %u%%",(DWORD)((100*dwdPressedDataLen)/dwdFileLen_in) );
			txt+=t+"\r\n";
		}


		#undef def_isPrint
	}


	//
	bool UnPackData(const BYTE* const pArhFile_in,const DWORD dwdArhFileLen_in,DWORD& dwdUnpackedFileLen_out)
	{
		return UnPackDataEx(pArhFile_in,dwdArhFileLen_in,dwdUnpackedFileLen_out);
	}

	// ,    
	bool UnPackData_JustCheckArhiveFormat(const BYTE* const pArhFile_in,const DWORD dwdArhFileLen_in)
	{
		DWORD dwd;
		return UnPackDataEx(pArhFile_in,dwdArhFileLen_in,dwd,true);
	}

	//
	//     pWinForMessages ,   
	//   MessageBox,   
	//(  )
	bool PackData(const BYTE* const pFile_in,const DWORD dwdFileLen_in,DWORD* pdwdPressedDataLen_out,const DWORD dwdLimitSize=0,CWnd* pWinForMessages=0)
	{
		return PackDataEx(pWinForMessages,pFile_in,dwdFileLen_in,pdwdPressedDataLen_out,dwdLimitSize,false);
	}
};

/*
///////////////////////////////////////
// 
///////////////////////////////////////

// 

CHuffman Huff;

BYTE* pFile=...;//
DWORD dwdFileLen=...;// 

DWORD dwdPressedDataLen=0;

if(!Huff.PackData(pFile,dwdFileLen,&dwdPressedDataLen))
{
	//
	//...
}

//Huff.pArhivBuffer -    
//dwdPressedDataLen -   

///////////////////////////////////////

//

BYTE* pArhiv=...;//  
DWORD dwdArhLen=...;// 

CHuffman Huff;
DWORD dwdUnpackedFileLen=0;

if(!Huff.UnPackData(pArhiv,dwdArhLen,dwdUnpackedFileLen))
{
	MessageBox("  ");
	return false;
}

//Huff.pUnpackBuffer -    
//dwdUnpackedFileLen -  


///////////////////////////////////////

*/